;;;; -*- mode:Scheme -*- ;;;;
;;
;; loader.scm
;; 
;; This is the file you actually want to execute.
;; It loads all five code files, then the knowledge file, 
;; then executes a best-first search for the desired solution.
;;

;; Load the files (compiled or otherwise):

(cd "/mit/6.034/Project/SUNbin")
(load "search")
(load "rule-utils")
(load "forward")
(load "match")
(load "schedule")
(cd "/mit/catfoo/6.034/")

(read-k-file "rules.txt")

;(display-assertions)

(define (extend-path path)
;  (display* "Extending the path " (path-reverse path))
  (remove-falses
   (map
     (lambda (next-node)
      (if (member next-node (path-nodes path))
          #f
          (make-path
           #f                           ; path value is not relevant here
           (cons next-node (path-nodes path)))))
    (get-neighboring-nodes (path-head-node path)))))

(define (get-heuristic-value node finish)
  (define (loop assertions score)
    (cond ((null? assertions) score)
	  ((member (car assertions) node)
	   (loop (cdr assertions) (- score 5)))
	  (else
	   (loop (cdr assertions) (+ score 1)))))
  (loop finish 0))
;  0)


(define (last node)
  (if (null? (cdr node))
      node
      (last (cdr node))))

(define (describe-path path)
  (display* "the final state is: " (last path) (count (car (last path))))
  ;(last path)
  'ok)

(define (extend-path-with-heuristic path heuristic)
  ;(display* "Extending the pathheadnode " 
 (display* (last (path-head-node path)))
;)
  (remove-falses
   (map
    (lambda (next-node)
      (if (member next-node (path-nodes path))
          #f
          (make-path
           (heuristic next-node)        ; path value is from calling heuristic
           (cons next-node (path-nodes path)))))
    (get-neighboring-nodes (path-head-node path)))))

(define (count list)
  (define (count-help list tally)
    (if (null? list)
	tally
	(count-help (cdr list) (+ 1 tally))))
  (count-help list 0))

(best-first *assertions* '(
(6III has TA)
(6AAA has TA)
 (6BBB has TA) (6CCC has TA) (6DDD has TA)
(6MMM has TA) (6NNN has TA) 
;(6034 has TA) (6EEE has TA)
))

(get-step-count)

;(read-k-file "ta-schedule.k.txt")

;(display-assertions)

;(best-first *assertions* '((6.001 has a ta)(6.002 has a ta)(6.034 has a ta)))
;(get-step-count)
