void repCheck() {

  Object curnode;
  EdgeSet curedges;
  Edge thisedge;
  
  // check that all the edges actually originate from the
  // node they are associated with, and that they point to
  // a node that exists.
  
  for(Iterator allNodes = getNodes().iterator(); allNodes.hasNext(); ) {
    curnode = allNodes.next();
    curedges = getEdges(curnode);
    for(Iterator alledges = curedges.iterator(); alledges.hasNext(); ) {
      thisedge = alledges.next();
      if (!(thisedge.origin()).equals(curnode))
	throw new RuntimeException("edge origin error!");
      else if (! containsNode(thisedge.dest()))
	throw new RuntimeException("edge dest error!");

      // check that each edge has an origin, destination, and label.
      
      else if (thisedge.origin() == null)
	throw new RuntimeException("edge origin is null!");
      else if (thisedge.dest() == null)
	throw new RuntimeException("edge dest is null!");
      else if (thisedge.label() == null)
	throw new RuntimeException("edge label is null!");
    }
  }
  
}



Abstraction Function

graph = nodes + edges
set of nodes = Graph.getNodes();
set of edges = union of all sets from Graph.getEdges(node);


String toString() { 
  String graphstring = null;

  Object curnode;
  EdgeSet curedges;
  Edge thisedge;
  
  for(Iterator allNodes = getNodes().iterator(); allNodes.hasNext(); ) {

    curnode = allNodes.next();
    graphstring = graphstring + curnode + ":\n";

    curedges = getEdges(curnode);

    for(Iterator alledges = curedges.iterator(); alledges.hasNext(); ) {
      thisedge = alledges.next();
      graphstring = graphstring + "\t" + thisedge.label() + " --> " + thisedge.dest + "\n";
    }
  }
}
	 
