package ex6.ui;

import javax.swing.JOptionPane;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JTextField;
import java.beans.*; //Property change stuff
import java.awt.*;
import java.awt.event.*;

class StockEntryDialog extends JDialog {
    private String shareinfoText[] = null;

    private String prompt;
    private JOptionPane optionPane;
    private String title;
  final JTextField tickerField = new JTextField(6);
  final JTextField sharesField = new JTextField(8);
  final JTextField priceField  = new JTextField(6);
  
  
  
    public String[] getValidatedText() {
        return shareinfoText;
    }

  public void initialize(String ttl, String temptick, int tempsh, float temppr) {

    setTitle(ttl);
    tickerField.setText(temptick);
    sharesField.setText(tempsh);
    priceField.setText(temppr);
  }

  
    public StockEntryDialog(String ttl, JFrame parent) {
        super(parent, true);
        final JFrame jf = parent;
 
	title = ttl;
        setTitle(title);
	

        Object[] array = {"Ticker Symbol: ", tickerField,
			  " Shares Held: ", sharesField,
			  " Price: ", priceField};

        final String btnString1 = "OK";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        optionPane = new JOptionPane(array, 
                                    JOptionPane.QUESTION_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options,
                                    options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        tickerField.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                optionPane.setValue(btnString1);
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener()
{
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                          //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnString1)) {
		      shareinfoText = new String[3];
		      shareinfoText[0] = tickerField.getText();
		      shareinfoText[1] = sharesField.getText();
		      shareinfoText[2] = priceField.getText();
		      // String ucText = typedText.toUpperCase();
		      if (shareinfoText[0] != null &&
			  shareinfoText[1] != null &&
			  shareinfoText[2] != null) {  // we have to check for uniqueness!
			// we're done; dismiss the dialog
			setVisible(false);
		      } else { 
			// text was invalid
			tickerField.selectAll();
			JOptionPane.showMessageDialog(StockEntryDialog.this,
						      "Sorry, please enter values for the ticker, price, and shares held.",
							"Try again",
						      JOptionPane.ERROR_MESSAGE);
			shareinfoText = null;
		      }
                    } else { // user closed dialog or clicked cancel
                        shareinfoText = null;
                        setVisible(false);
                    }
                }
            }
	  });
    }
}
