import java.awt.*;
import java.awt.image.*;
import Raster;
import Sprite;


class Playfield extends Raster {
    Raster background;          // background image
    Sprite sprite[];    // list of sprites on this playfield
    Image background2;
    int last_x, last_y;
    
    public Playfield(Image bgnd, int numSprites)
    {
         
        super(200,200);
        background = new Raster(bgnd);
        sprite = new Sprite[numSprites];
        last_x = 0;
        last_y = 0;
        scrollBackground(0,0);
        //}

    }
    public void addSprite(int i, Sprite s)
    {
        sprite[i] = s;
        //      i++;
    }
    
    public boolean anyTransparent(int x, int y)
    {
	boolean trans = true;
	int numSprites = sprite.length;
	for (int i=0; i<numSprites; i++){
	    if (!sprite[i].isTransparent(x,y))
		trans = false;
	}
	return trans;
    }
    public void spritesmousedown(int x, int y) 
    {
	int numSprites = sprite.length;
	boolean anyyet = false;
	for (int i=0; i<numSprites; i++){
	    if (sprite[i].isTransparent(x,y))
		sprite[i].moving = false;
	    else {
		sprite[i].moving = true;
		anyyet = true;
	    }
	}
    }

    public void spritesmouseup(int x, int y) 
    {
	int numSprites = sprite.length;
	for (int i=0; i<numSprites; i++)
	    sprite[i].moving=false;
	
    }

    public void spritesmousedrag(int x, int y) 
    {
	int numSprites = sprite.length;
	for (int i=0; i<numSprites; i++){
	    if (sprite[i].moving) {
		sprite[i].x = x;
		sprite[i].y = y;
	    }
	}
	
    }

    public void Draw( )
    {
	int numSprites = sprite.length;
	
	for (int i = 0; i<numSprites;i++)
	    sprite[i].fixbackground(this);
	
	for (int i = 0; i<numSprites;i++)
	    sprite[i].Draw(this);
        


    }
    
    public void scrollBackground(int dx, int dy)
    {
        int wid = getWidth();
        int hei = getHeight();
        int bwid = background.getWidth();
        int bhei = background.getHeight();
        if (last_x+dx > bwid-wid) dx = bwid-wid - last_x;
        if (last_y+dy > bhei-hei) dy = bhei-hei - last_y;
        if (last_x+dx < 0) dx = -1*last_x;
        if (last_y+dy < 0) dy = -1*last_y;
        for (int i = 0; i<wid; i++) {
            for (int j = 0; j<hei; j++) {
              setPixel(background.getPixel(i+last_x+dx,j+last_y+dy), i, j);
                    }
        }
        last_x = last_x + dx;
        last_y = last_y + dy;
           
    }
    
    void refreshBackground(int x, int y, int w, int h)
    {
        
        //int wid = background.getWidth();
        //int hei = background.getHeight();
        for (int i = 0; i<w; i++) {
            for (int j = 0; j<h; j++) {
              setPixel(background.getPixel(i+last_x+x,j+last_y+y), i+x, j+y);
                    }
    }

    }
}









