import java.applet.Applet;
import java.awt.*;
import java.util.Vector;

/** Applet mas110runner
*  
*  @author   Tom White
*  @version  1.0
*/
public class mas110runner
  extends java.applet.Applet
  implements java.lang.Runnable {
	//This panel handles output
	mas110panel mainPanel, activePanel;
	Image buf;
	Graphics g;
	float speed = 1.0f, globalMx = 0.5f, globalMy = 0.5f;
	int w, h;
	Vector names, panels;
	boolean panelsFound=false, resetEpoch=false;
	Choice choice;
	Scrollbar speedBar, mxBar, myBar;
	Label speedLabel, mxLabel, myLabel;
	
	public static final String name    = "mas110runner";
	public static final String version = "1.0";
	
	Thread	runner;
	
	public void doLoad(String className) {
		Class cl;
		Object o;
		mas110panel p;

		try {
			cl = Class.forName(className);
			o = cl.newInstance();
			if(o instanceof mas110panel) {
				p = (mas110panel)o;
				if(!panelsFound) {
					panelsFound = true;
					names = new Vector();
					panels = new Vector();
				}				
				names.addElement(className);
				p = (mas110panel)o;
				p.w = w;
				p.h = h;
				panels.addElement(p);
			}
		}
		catch(Exception e) {
			System.out.println("problem loading " + className + ": " + e);
		}
	}

	void getApps() {
		int i=1;
		boolean stop=false;
		String file;
		
		while(!stop) {
			file = getParameter("panel" + i);
			if(file != null && file.length() > 0) {
				doLoad(file);
				++i;
			}
			else stop=true;
		}
	}			

	/** Performs applet initialization 
	*/
	public void init()
	{
		// Make the input and output panels
 		mainPanel = new mas110panel();
		w = h = 101;
		mainPanel.w = w;
		mainPanel.h = h;
		buf = createImage(w, h);
		g = buf.getGraphics();
		// 
		//Initialize this applet to a Bordered-Layout()
		setLayout(new BorderLayout());

		getApps();
		if(!panelsFound) activePanel=mainPanel;
		else {
			names.addElement("Test Pattern");
			panels.addElement(mainPanel);
			choice = new Choice();
			for(int i=0;i<names.size();i++) {
				choice.addItem((String)names.elementAt(i));
			}
			add("North", choice);
			activePanel = (mas110panel)panels.elementAt(0);
			choice.select(0);
		}
		Panel p = new Panel();
		p.setLayout(new GridLayout(3, 2, 1, 1));
		
		speedLabel = new Label("speed = " + speed);
		p.add(speedLabel);
		speedBar = new Scrollbar(Scrollbar.HORIZONTAL, 30, 10, 0, 100);
		p.add(speedBar);

		mxLabel = new Label("mx = " + globalMx);
		p.add(mxLabel);
		mxBar = new Scrollbar(Scrollbar.HORIZONTAL, 50, 10, 0, 100);
		p.add(mxBar);
		
		myLabel = new Label("my = " + globalMy);
		p.add(myLabel);
		myBar = new Scrollbar(Scrollbar.HORIZONTAL, 50, 10, 0, 100);
		p.add(myBar);

		add("South", p);
		show();
		resetEpoch=true;
	}

	public boolean handleEvent(Event evt) {
		int s;
		
		if(evt.target == choice && evt.id == Event.ACTION_EVENT) {
			int w = choice.getSelectedIndex();
			activePanel = (mas110panel)panels.elementAt(w);
			resetEpoch = true;
/*
			speedbar.setValue(50);
			speed = 1.0f;
			label.setText("" + speed);
*/
			return true;
		}
		else if(evt.target == speedBar) {
			s = speedBar.getValue();
			speed = (s/30.0f);
			speed = speed*speed*speed;
			speedLabel.setText("speed = " + speed);
			//System.out.println("Speed is now " + speed);
			return true;
		}
		else if(evt.target == mxBar) {
			s = mxBar.getValue();
			globalMx = (s/100.0f);
			mxLabel.setText("mx =  " + globalMx);
			//System.out.println("Speed is now " + speed);
			return true;
		}
		else if(evt.target == myBar) {
			s = myBar.getValue();
			globalMy = (s/100.0f);
			myLabel.setText("my = " + globalMy);
			//System.out.println("Speed is now " + speed);
			return true;
		}
		return false;
	}
	
	/** Draws the applet.
	*/
	public void paint(Graphics g)
	{
		Dimension d = size();
		if(buf!=null) 
			g.drawImage(buf, (d.width-w)/2, (d.height-h)/2, null);
		Toolkit.getDefaultToolkit().sync(); 
	}
	
	public void update(Graphics g) {
		paint(g);
	}

	//That box won't look cute if you don't see it
	public Insets insets() 
	{
		return new Insets(5,5,5,5);
	}
	
	/** The main entry point for the applet.
	*/
	public void start()
	{
		// Either start the applet here or create 
		// a thread to run the applet in.
		
		if (runner == null)
		{
			runner = new Thread(this);
			runner.start();
		}
	}
	
	/** Called when you create a new thread with this class.
	*/
	public void run()
	{
		long then, now, napTime, epoch;
		
		epoch = System.currentTimeMillis();
		while (runner == Thread.currentThread()) 
		{
			then = System.currentTimeMillis();
			if(resetEpoch) {
				epoch = then;
				resetEpoch = false;
			}			

			// move the kite, compute the new points
//			bitPanel.step();
			activePanel.mx = globalMx;
			activePanel.my = globalMy;
			activePanel.draw(g, (float)(speed*(then-epoch))/1000.0f);
			paint(this.getGraphics());
//			repaint();
			
			// repeat every frameInterval milliseconds
			
			try { Thread.sleep(5); }
			catch (InterruptedException e) { }
			now = System.currentTimeMillis();
			/* you can change 100 to something else, like a frigging constant */
			napTime = 20 - (now - then);
			if (napTime > 0) {
			//System.out.println("Sleeping " + napTime);
				try { Thread.sleep(napTime); }
				catch (InterruptedException e) {}
			}
/*
			else 
			{
				Thread.yield();
			}
*/
		}
	}
	
	/** Stops the applet from executing.
	*/
	public void stop()
	{
		// Stop the applet or the thread it's running in.
				
		if (runner != null)
		{
			// only sandmen kill runners
			runner.stop();
			runner = null;
		}
	}
	
	/** Free up any applet resources.
	*/
	public void destroy()
	{
		// Dispose of images, net connections, windows, etc.
	}
	
	/** Returns a text description of the applet.
	*/
	public String getAppletInfo()
	{
		// Return a String containing author, version, copyright, 
		// and other information.
		
		return name + " version " + version;
	}
	
	/** Clean up done here.
	*  This method is called when the object is collected.
	*  @throws Throwable
	*/
	protected void finalize()
	{
		// Put any code here you want to execute when the 
		// object is collected, such as closing sockets 
		// or files.
	}
	
}
