// defs.h
// definitions for blockfind

// this is only used to calculate coverage in printstats.
// i.e. total block length / chromosome length
#define LENGTH 1e5

// this used to be the LD threshold. it sets a couple variables.
#define THRESHOLD .90

// the "95% info pairs in LD" parameter.
#define CUTOFF .95 

// the maximum number of SNPs.
// sorry memory isn't allocated dynamically in this program..
#define MAXSNPS 17370

// the maximum number of LD entries per snp.
// (i.e. the width of the array)
#define MAXSNPSPERSNP 3000

// the maximum block that you'll look for, in bases.
// i use 200kb as a safe estimate - altshuler paper max block length
// is 174kb. [Gabriel et al. Science 296: 2225-2229]
#define MAXBLOCKLENGTH 200000

// the gap that we allow for between blocks, in bases.
// 200 based on size of recombination hotspot found in [Jeffreys,
// Kauppi, and Neumann. Nature Genetics 29: 217-222]
#define GAP 200
