#!/bin/csh

set filestorun = "0 1 2 3 4 5 6 7 8 9"

foreach filenum ($filestorun)

set fileprefix = "bneck2.$filenum"

set filename = "$fileprefix.out"
set nodupsfile = "$fileprefix.nodups.out"
set tscedfile = "$fileprefix.tsc.out"
set outputfile = "$fileprefix.tsc2.out"

echo $filename $nodupsfile $tscedfile

cat Simulated_Pops/Bottleneck2/$filename | awk '{if ($1 != last) print $0; last=$1}' > ! $nodupsfile

cat $nodupsfile | nawk 'BEGIN{ \
    numsnippets = 2000;\
    for (i=1; i<= numsnippets; i++) snippet[i] = int(rand()*1e6);\
    for (i=1; i<= numsnippets; i++) chrom[i] = int(rand()*100);\
    ref = 100;} \
    { for (i = 1; i <= numsnippets; i++) {\
	if (snippet[i] > 0) {\
	    if ($1 > snippet[i]+500) snippet[i]=-1;\
	    else {\
		if ($1 > snippet[i] && $1 < snippet[i]+500) { \
		    if (substr($4, chrom[i],1) != substr($4,ref,1)) print $0}; \
    }}}}'	> ! $tscedfile


sort -n $tscedfile | awk '{if ($1 != last) print $0; last = $1}' > ! $outputfile

end
